"TEST FILE FOR BOGUSFORTH (bf) version 0.9.0"i..
"Made by A. Maschio 2004"i..

"Commands not tested (do it manually)"i.
"  g (random numbers)"i.
"  ( (executes file)"i.
"  ` (ascii code from char)"i.
"  . (CR - widely tested throughout this test!)"i.
"  all the system commands:"i.
..
"BEGINNING OF TEST"i..

"-------------------"i.
"NEGATION EXECUTION (\)"i.
)100\i.
"Should report -100"i.

"-------------------"i.
"VARIABLE STORING EXECUTION (!)"i.
"(look at the end of file for the correct values)"i.
"Storing 46782, \"a string\" and [1 3+i.] in all the variables step 3"i.
46782a!"a string"b![1 3+i.]c!46782d!"a string"e![1 3+i.]f!
46782g!"a string"h![1 3+i.]i!46782j!"a string"k![1 3+i.]l!
46782m!"a string"n![1 3+i.]o!46782p!"a string"q![1 3+i.]r!
46782s!"a string"t![1 3+i.]u!46782v!"a string"w![1 3+i.]x!
46782y!"a string"z!
46782A!"a string"B![1 3+i.]C!46782D!"a string"E![1 3+i.]F!
46782G!"a string"H![1 3+i.]I!46782J!"a string"K![1 3+i.]L!
46782M!"a string"N![1 3+i.]O!46782P!"a string"Q![1 3+i.]R!
46782S!"a string"T![1 3+i.]U!46782V!"a string"W![1 3+i.]X!
46782Y!"a string"Z!
"-------------------"i..

"-------------------"i.
"EMPTY STACK EXECUTION (\")\")"i.
"Storing 3 numbers on tos: 23, 7892, -986752, emptying and then reporting"i.
23 7892 986752\):
"Should report: (empty stack)"i.
"-------------------"i..

"-------------------"i.
"IF-THEN EXECUTION (?)"i.
"Executing the following: 1[\"TRUE\"i.]?"i.
1["TRUE"i.]?
"Should report: TRUE"i.
"Executing the following: 0[\"FALSE\"i.]?"i.
0["FALSE"i.]?
"Should report: nothing"i.
"-------------------"i..

"-------------------"i.
"IF-THEN-ELSE EXECUTION (?)"i.
"Executing the following: 1[\"TRUE\"i.][\"FALSE\"i.]?"i.
1["TRUE"i.]["FALSE"i.]?
"Should report: TRUE"i.
"Executing the following: 0[\"TRUE\"i.][\"FALSE\"i.]?"i.
0["TRUE"i.]["FALSE"i.]?
"Should report: FALSE"i.
"-------------------"i..

"-------------------"i.
"FUNCTION EXECUTION (@)"i.
"Executing the following: [3 4+7=[\"OK\"i.]?]"i.
[3 4+7=["OK"i.]?]@
"Should report: OK"i.
"-------------------"i..

"-------------------"i.
"TEAR LINE EXECUTION (t)"i.
"Storing on tos 1, 2 and 3, putting t after 1 and printing"i.
)1t2 3 
i.)
"Should report: 1"i.
"-------------------"i..

"-------------------"i.
"DUP EXECUTION (%)"i.
"Storing on tos 23, \"a string\" and [1 3+i.], dupping them one by one"i.
23%
"a string"%
[1 3+i.]%
:)
"Should report: double copy of the 3 entities, with numbers on bottom"i.
"-------------------"i..

"-------------------"i.
"DROP EXECUTION (;)"i.
"Storing on tos 23, \"a string\" and [1 3+i.], dropping them one by one"i.
23;
"a string";
[1 3+i.];
:)
"Should report: (empty stack)"i.
"-------------------"i..

"-------------------"i.
"SWAP EXECUTION ($)"i.
"Storing on tos 23, \"a string\" and [1 3+i.]"i.
23 "a string" [1 3+i.]:
"Should report the 3 entities, with number on bottom"i.
"swapping and dropping"i.
$:;
"Should report function and string swapped"i.
"swapping"i.
$:
"Should report function and number, with function on bottom"i.
)
"-------------------"i..

"-------------------"i.
"ROT EXECUTION (_)"i.
"Storing 10 \"20\" [30] on tos"i.
10 "20" [30]:
"Should report the 3 entities, win 10 on bottom"i.
"Roting"i._:
"Should report 10 on tos"i.
"Roting"i._:
"Should report \"20\" on tos"i.
"Roting"i._:
"Should report [30] on tos"i.
)
"-------------------"i..

"-------------------"i.
"ROLL EXECUTION (r)"i.
"Storing 10 -100 \"20\" [30] 45678912 on tos"i.
10 100\ "20" [30] 45678912:
"Should report all the entities, with 10 on bottom"i.
"Rolling 4"i.4r :
"Should report -100 on tos"i.
"Rolling 5"i.5r :
"Should report 10 on tos"i.
"Rolling 3 (roting)"i.3r :
"Should report 45678912 on tos"i.
"Redoing all for testing with rot"i.)
10 100\ "20" [30] 45678912 4r5r_:
"Should report 45678912 on tos as before"i.
)
"-------------------"i..

"-------------------"i.
"PICK EXECUTION (p)"i.
"Storing 10 -100 \"20\" [30] 45678912 on tos"i.
10 100\ "20" [30] 45678912:
"Should report all the entities, win 10 on bottom"i.
"Picking 4"i.4p :
"Should report the same as before with a copy of -100 on tos"i.
"Picking 5"i.5p :
"Should report two copies of -100 on tos"i.
)
"-------------------"i..

"-------------------"i.
"STACK DEPTH EXECUTION"i.
"Storing 10 -100 \"20\" [30] 45678912 on tos"i.
10 100\ "20" [30] 45678912:
"Should report all the entities, win 10 on bottom"i.
}i.
"Should report: 5"i.
)
"-------------------"i..

"-------------------"i.
"MULTIPLICATION EXECUTION (*)"i.
"Multiplying 10 and 427"i.
10 427*i.
"Should report 4270"i.
"Multiplying -10 and -427"i.
10\ 427\*i.
"Should report 4270"i.
"Multiplying 10 and -427"i.
10 427\*i.
"Should report -4270"i.
"Multiplying -10 and 427"i.
10\ 427*i.
"Should report -4270"i.
"-------------------"i..

"-------------------"i.
"ADDITION EXECUTION (+)"i.
"Adding 10 and 427"i.
10 427+i.
"Should report 437"i.
"Adding -10 and -427"i.
10\ 427\+i.
"Should report -437"i.
"Adding 10 and -427"i.
10 427\+i.
"Should report -417"i.
"Adding -10 and 427"i.
10\ 427+i.
"Should report 417"i.
"-------------------"i..

"-------------------"i.
"SUBTRACTION EXECUTION (-)"i.
"Subtracting 427 from 10"i.
10 427-i.
"Should report -417"i.
"Subtracting -427 from -10"i.
10\ 427\-i.
"Should report 417"i.
"Subtracting -427 from 10"i.
10 427\-i.
"Should report 437"i.
"Subtracting 427 from -10"i.
10\ 427-i.
"Should report -437"i.
"-------------------"i..

"-------------------"i.
"INTEGER DIVISION EXECUTION (/)"i.
"Dividing 427 by 10"i.
427 10/i.
"Should report 43"i.
"Dividing -427 by -10"i.
427\10\/i.
"Should report 43"i.
"Dividing -427 by 10"i.
427\ 10/i.
"Should report -43"i.
"Dividing 427 by -10"i.
427 10\/i.
"Should report -43"i.
"-------------------"i..

"-------------------"i.
"MODULUS EXECUTION (m)"i.
"Modulus of 427 and 10"i.
427 10mi.
"Should report 7"i.
"Modulus of -427 and -10"i.
427\10\mi.
"Should report -7"i.
"Modulus of -427 and 10"i.
427\ 10mi.
"Should report -7"i.
"Modulus of 427 and -10"i.
427 10\mi.
"Should report 7"i.
"Remainder Should always have the same sign of dividend"i.)
"-------------------"i..

"-------------------"i.
"POWER EXECUTION (^)"i..
"Normal base/exponent"i.
"Base 40, exponent 3"i.
40 3^i.
"Should be 64000"i.
"Base 40, exponent -3"i.
40 3\^i.
"Should be 0"i.
"Base -40, exponent 3"i.
40\ 3^i.
"Should be -64000"i.
"Base -40, exponent -3"i.
40\ 3\^i.
"Should be 0"i..
"Peculiar base/exponent"i.
"Base 0, exponent 3"i.
0 3^i.
"Should be 0 (really 0)"i.
"Base 40, exponent 0"i.
40 0^i.
"Should be 1"i.
{"Base and exponent 0"i.
{0 0^i.
{"Should do nothing (error)"i.
"-------------------"i..

"-------------------"i.
"ROOT EXECUTION (!)"i..
"Odd root"i.
"Base 27, root 3"i.
27 3!i.
"Should be 3"i.
"Base 27, root -3"i.
27 3\!i.
"Should be 0 (in reality 1/3)"i.
"Base -27, root 3"i.
27\3!i.
"Should be -3"i.
"base -27, root -3"i.
27\3\!i.
"Should be 0 (in reality -1/3)"i..
"Even root"i.
"Base 27, root 2"i.
27 2!i.
"Should be 5"i.
"Base 27, root -2"i.
27 2\!i.
"Should be 0 (in reality 0.192...)"i.
{"Base -27, root 2"i.
{27\2!i.
{"Should do nothing (error)"i.
{"base -27, root -2"i.
{27\2\!i.
{"Should do nothing (error)"i.
"Zero base, odd root"i.
0 3!i.
"Should be 0 (really 0)"i.
"Zero base, even root"i.
0 2!i.
"Should be 0 (really 0)"i.
{"Base 27, zero root"i.
{27 0!i.
{"Should do nothing (error)"i.
{"Base -27, zero root"i.
{27\ 0!i.
{"Should do nothing (error)"i.
{"Base and root 0"i.
{0 0!i.
{"Should do nothing (error)"i.
"-------------------"i..

"-------------------"i.
"EQUAL TEST EXECUTION (=)"i.
"testing 23 = 23"i.
23 23=i.
"Should report 1"i.
"testing 56 = 23"i.
56 23=i.
"Should report 0"i.
"testing \"23\" = \"23\""i.
"23" "23"=i.
"Should report 1"i.
"testing \"56\" = \"23\""i.
"56" "23"=i.
"Should report 0"i.
"testing [23] = [23]"i.
[23][23]=i.
"Should report 1"i.
"testing [56] = [23]"i.
[56] [23]=i.
"Should report 0"i.
{"testing \"23\" = 23"i.
{"23" 23=i.
{"Should do nothing (error)"i.
{"testing [56] = \"23\""i.
{[56] "23"=i.
{"Should do nothing (error)"i.
{"testing [56] = 23"i.
{[56] 23=i.
{"Should do nothing (error)"i.
"-------------------"i..

"-------------------"i.
"GREATER THAN TEST EXECUTION (>)"i.
"testing 23 > 23"i.
23 23>i.
"Should report 0"i.
"testing 56 > 23"i.
56 23>i.
"Should report 1"i.
"testing \"23\" > \"23\""i.
"23" "23">i.
"Should report 0"i.
"testing \"56\" > \"23\""i.
"56" "23">i.
"Should report 1"i.
"testing [23] > [23]"i.
[23][23]>i.
"Should report 0"i.
"testing [56] > [23]"i.
[56] [23]>i.
"Should report 1"i.
{"testing \"23\" > 23"i.
{"23" 23>i.
{"Should do nothing (error)"i.
{"testing [56] > \"23\""i.
{[56] "23">i.
{"Should do nothing (error)"i.
{"testing [56] > 23"i.
{[56] 23>i.
{"Should do nothing (error)"i.
"-------------------"i..

"-------------------"i.
"AND EXECUTION (&)"i.
"Testing 1 & 1"i.
1 1&i.
"Should report 1"i.
"Testing 1 & 0"i.
1 0&i.
"Should report 0"i.
"Testing 0 & 1"i.
0 1&i.
"Should report 0"i.
"Testing 0 & 0"i.
0 0&i.
"Should report 0"i.
"-------------------"i..

"-------------------"i.
"OR EXECUTION (|)"i.
"Testing 1 | 1"i.
1 1|i.
"Should report 1"i.
"Testing 1 | 0"i.
1 0|i.
"Should report 1"i.
"Testing 0 | 1"i.
0 1|i.
"Should report 1"i.
"Testing 0 | 0"i.
0 0|i.
"Should report 0"i.
"-------------------"i..

"-------------------"i.
"XOR EXECUTION (l)"i.
"Testing 1 l 1"i.
1 1li.
"Should report 0"i.
"Testing 1 l 0"i.
1 0li.
"Should report 1"i.
"Testing 0 l 1"i.
0 1li.
"Should report 1"i.
"Testing 0 l 0"i.
0 0li.
"Should report 0"i.
"-------------------"i..

"-------------------"i.
"NOT EXECUTION (`)"i.
"Testing ~1"i.
1~i.
"Should report 0"i.
"Testing 0"i.
0~i.
"Should report 1"i.
"-------------------"i..

"-------------------"i.
"BITWISE AND EXECUTION (a)"i.
"Testing 1010101B (85)"i.
"    and 0101011B (43)"i.
1010101B 0101011B ai.
"Should report 1"i.
"-------------------"i..

"-------------------"i.
"BITWISE OR EXECUTION (o)"i.
"Testing 1010101B (85)"i.
"     or 0101011B (43)"i.
1010101B 0101011B oi.
"Should report 127"i.
"-------------------"i..

"-------------------"i.
"BITWISE XOR EXECUTION (x)"i.
"Testing 1010101B (85)"i.
"    xor 0101011B (43)"i.
1010101B 0101011B xi.
"Should report 126"i.
"-------------------"i..

"-------------------"i.
"BITWISE NOT EXECUTION (n)"i.
"Testing not 1010101B (85)"i.
1010101B ni.
"Should report -86"i.
"-------------------"i..

"-------------------"i.
"FIELDED OUTPUT EXECUTION (j)"i.
"Storing a big number on tos: 1434546478"i.
1434546478
"Printing it in a 15 chars field"i.
%15j.
"Printing it in a 5 chars field"i.
%5j.
"Printing it in a 2 chars field"i.
2j.
"Should always succeed"i.
"-------------------"i..

"-------------------"i.
"DIGITED OUTPUT EXECUTION (k)"i.
"Storing a big number on tos: 1434546478"i.
1434546478
"Printing it with 10 digits"i.
%10k.
"Should report: 0.1434546478"i.
"Printing it with 5 digits"i.
%5k.
"Should report: 14345.46478"i.
"Printing it with 2 digits"i.
2k.
"Should report: 14345464.78"i.
"-------------------"i..

"-------------------"i.
"INPUT FROM KEYBOARD EXECUTION (<)"i.
"Input your name: "i.<
"Hello, "ii.
"Should have appeared \"Hello, <your name>\""i.
"-------------------"i..

"-------------------"i.
"EMIT CHAR EXECUTION (')"i.
"Storing 65 on tos and emitting"i.
65'.
"Should have printed A"i.
"Storing -65 on tos and emitting"i.
65\'.
"Should have printed A"i.
"-------------------"i..

"-------------------"i.
"NUMBER CONVERSION EXECUTION (,)"i.
"Storing the string \"12345\" on tos"i.
"12345"
"converting it to number and adding 100"i.
,100+i.
"Should report: 12445 (the string has been correctly converted)"i.
"Storing the string \"jump12345\" on tos"i.
"jump12345"
"converting it to number and adding 100"i.
,100+i.
"Should report: 100 (the string has been converted to 0)"i.
"Storing the string \"12345jump\" on tos"i.
"12345jump"
"converting it to number and adding 100"i.
,100+i.
"Should report: 12445 (the string has been correctly converted)"i.
)
"-------------------"i..

"-------------------"i.
"EXTRACT CHAR & STRING LENGTH EXECUTION (e)"i.
"Storing string \"Apocalypse\" on tos"i.
"Apocalypse"
"Extracting 7th char (counting starts from 0)"i.
%6ei.
"Should report: y"i.
"Extracting string length"i.
1\ei.
"Should report: 10"i.
"-------------------"i..

"-------------------"i.
"UNVEILING FIRST CHAR EXECUTION (u)"i.
"Storing string \"Now\" on tos"i.
"Now"
"Unveiling first char ascii code"i.
ui.
"Should report: 78"i.
"-------------------"i.

"-------------------"i..
"VARIABLE FETCHING (!)"i.
"Fetching 46782, \"a string\" and [1 3+i.] from all variables step 3"i.
"and printing"i.)
"lowered letters:"i.
a:i.b:i.c:i.d:i.e:i.f:i.
g:i.h:i.i:i.j:i.k:i.l:i.
m:i.n:i.o:i.p:i.q:i.r:i.
s:i.t:i.u:i.v:i.w:i.x:i.
y:i.z:i..
"capital letters:"i.
A:i.B:i.C:i.D:i.E:i.F:i.
G:i.H:i.I:i.J:i.K:i.L:i.
M:i.N:i.O:i.P:i.Q:i.R:i.
S:i.T:i.U:i.V:i.W:i.X:i.
Y:i.Z:i..
"Check the values with the input values"i.
"-------------------"i..
..
"END OF TEST"i.
)0q
